package org.bitbucket.bradleysmithllc.webserviceshubclient.parameter;

import org.bitbucket.bradleysmithllc.webserviceshubclient.regexp.ParameterExpression;

import java.io.PrintWriter;
import java.util.List;

public interface ScopeSection
{
	void appendParameter(ParameterExpression pe);
	void appendParameter(Parameter pe);
	void appendParameter(String name, String value);
	void appendParameter(String mapplet, String name, String value);
	void appendParameter(String line);

	void write(PrintWriter output);

	String getHeader();

	String getWSHeader();

	enum section_type
	{
		global,
		integration_service,
		integration_service_with_node,

		folder_with_workflow,
		folder_with_workflow_and_worklet,
		folder_with_workflow_and_worklet_and_session,
		folder_with_session,

		session
	}

	section_type getType();

	String getIntegrationServiceName();
	String getIntegrationServiceNodeName();

	String getFolderName();
	String getWorkflowName();
	String getWorkletName();
	String getSessionName();

	List<Parameter> getParameters();
}